<?php
	/**
	 * This is a quick-and-dirty draft QForm object to do the List All functionality
	 * of the Todolist class.  It uses the code-generated
	 * TodolistDataGrid control which has meta-methods to help with
	 * easily creating/defining Todolist columns.
	 *
	 * Any display customizations and presentation-tier logic can be implemented
	 * here by overriding existing or implementing new methods, properties and variables.
	 * 
	 * NOTE: This file is overwritten on any code regenerations.  If you want to make
	 * permanent changes, it is STRONGLY RECOMMENDED to move both todolist_list.php AND
	 * todolist_list.tpl.php out of this Form Drafts directory.
	 *
	 * @package My QCubed Application
	 * @subpackage FormBaseObjects
	 */
	abstract class TodolistListFormBase extends QForm {
		// Local instance of the Meta DataGrid to list Todolists
		/**
		 * @var TodolistDataGrid dtgTodolists
		 */
		protected $dtgTodolists;

		// Create QForm Event Handlers as Needed

//		protected function Form_Exit() {}
//		protected function Form_Load() {}
//		protected function Form_PreRender() {}
//		protected function Form_Validate() {}

		protected function Form_Run() {
			parent::Form_Run();
		}

		protected function Form_Create() {
			parent::Form_Create();

			// Instantiate the Meta DataGrid
			$this->dtgTodolists = new TodolistDataGrid($this);

			// Style the DataGrid (if desired)
			$this->dtgTodolists->CssClass = 'datagrid';
			$this->dtgTodolists->AlternateRowStyle->CssClass = 'alternate';

			// Add Pagination (if desired)
			$this->dtgTodolists->Paginator = new QPaginator($this->dtgTodolists);
			$this->dtgTodolists->ItemsPerPage = 20;

			// Use the MetaDataGrid functionality to add Columns for this datagrid

			// Create an Edit Column
			$strEditPageUrl = __VIRTUAL_DIRECTORY__ . __FORM_DRAFTS__ . '/todolist_edit.php';
			$this->dtgTodolists->MetaAddEditLinkColumn($strEditPageUrl, 'Edit', 'Edit');

			// Create the Other Columns (note that you can use strings for todolist's properties, or you
			// can traverse down QQN::todolist() to display fields that are down the hierarchy)
			$this->dtgTodolists->MetaAddColumn('Id');
			$this->dtgTodolists->MetaAddColumn('Description');
		}
	}
?>
