<?php
	// Load the QCubed Development Framework
	require('../qcubed.inc.php');

	require(__FORMBASE_CLASSES__ . '/TimetrackEditFormBase.class.php');

	/**
	 * This is a quick-and-dirty draft QForm object to do Create, Edit, and Delete functionality
	 * of the Timetrack class.  It uses the code-generated
	 * TimetrackMetaControl class, which has meta-methods to help with
	 * easily creating/defining controls to modify the fields of a Timetrack columns.
	 *
	 * Any display customizations and presentation-tier logic can be implemented
	 * here by overriding existing or implementing new methods, properties and variables.
	 * 
	 * NOTE: This file is overwritten on any code regenerations.  If you want to make
	 * permanent changes, it is STRONGLY RECOMMENDED to move both timetrack_edit.php AND
	 * timetrack_edit.tpl.php out of this Form Drafts directory.
	 *
	 * @package My QCubed Application
	 * @subpackage Drafts
	 */
	class TimetrackEditForm extends TimetrackEditFormBase {
		// Override Form Event Handlers as Needed
		protected function Form_Run() {
			parent::Form_Run();

			// Security check for ALLOW_REMOTE_ADMIN
			// To allow access REGARDLESS of ALLOW_REMOTE_ADMIN, simply remove the line below
			QApplication::CheckRemoteAdmin();
		}

//		protected function Form_Load() {}

//		protected function Form_Create() {}

		protected function Form_Validate() {
			// By default, we report that Custom Validations passed
			$blnToReturn = true;
			// modification  by magia 2012 as suggested in qcubed-quick-start-guide_v210_Chapt_05 validation
			// Custom Validation Rules
			// TODO: Be sure to set $blnToReturn to false if any custom validation fails!
			
			if ($this->calStartTime->DateTime > $this->calEndTime->DateTime){ 
				$this->calEndTime->Warning = "Start time must be smaller then endtime";
				$blnToReturn =  false;
			}

			$blnFocused = false;
			foreach ($this->GetErrorControls() as $objControl) {
				// Set Focus to the top-most invalid control
				if (!$blnFocused) {
					$objControl->Focus();
					$blnFocused = true;
				}

				// Blink on ALL invalid controls
				$objControl->Blink();
			}

			return $blnToReturn;
		}

		
		
		// modification  by magia 2012 as suggested in qcubed-quick-start-guide_v210_Chapt_05 step 2
		protected function RedirectToListPage() {
			QApplication::Redirect(__SUBDIRECTORY__.'/timetrack/timetrack_list.php');
		}
	
	}

	// Go ahead and run this form object to render the page and its event handlers, implicitly using
	// timetrack_edit.tpl.php as the included HTML template file
	TimetrackEditForm::Run('TimetrackEditForm');
?>