<?php
	/**
	 * This is a quick-and-dirty draft QForm object to do the List All functionality
	 * of the Timetrack class.  It uses the code-generated
	 * TimetrackDataGrid control which has meta-methods to help with
	 * easily creating/defining Timetrack columns.
	 *
	 * Any display customizations and presentation-tier logic can be implemented
	 * here by overriding existing or implementing new methods, properties and variables.
	 * 
	 * NOTE: This file is overwritten on any code regenerations.  If you want to make
	 * permanent changes, it is STRONGLY RECOMMENDED to move both timetrack_list.php AND
	 * timetrack_list.tpl.php out of this Form Drafts directory.
	 *
	 * @package My QCubed Application
	 * @subpackage FormBaseObjects
	 */
	abstract class TimetrackListFormBase extends QForm {
		// Local instance of the Meta DataGrid to list Timetracks
		/**
		 * @var TimetrackDataGrid dtgTimetracks
		 */
		protected $dtgTimetracks;

		// Create QForm Event Handlers as Needed

//		protected function Form_Exit() {}
//		protected function Form_Load() {}
//		protected function Form_PreRender() {}
//		protected function Form_Validate() {}

		protected function Form_Run() {
			parent::Form_Run();
		}

		protected function Form_Create() {
			parent::Form_Create();

			// Instantiate the Meta DataGrid
			$this->dtgTimetracks = new TimetrackDataGrid($this);

			// Style the DataGrid (if desired)
			$this->dtgTimetracks->CssClass = 'datagrid';
			$this->dtgTimetracks->AlternateRowStyle->CssClass = 'alternate';

			// Add Pagination (if desired)
			$this->dtgTimetracks->Paginator = new QPaginator($this->dtgTimetracks);
			$this->dtgTimetracks->ItemsPerPage = __FORM_DRAFTS_FORM_LIST_ITEMS_PER_PAGE__;

			// Use the MetaDataGrid functionality to add Columns for this datagrid

			// Create an Edit Column
			$strEditPageUrl = __VIRTUAL_DIRECTORY__ . __FORM_DRAFTS__ . '/timetrack_edit.php';
			$this->dtgTimetracks->MetaAddEditLinkColumn($strEditPageUrl, 'Edit', 'Edit');

			// Create the Other Columns (note that you can use strings for timetrack's properties, or you
			// can traverse down QQN::timetrack() to display fields that are down the hierarchy)
			$this->dtgTimetracks->MetaAddColumn('Id');
			$this->dtgTimetracks->MetaAddColumn(QQN::Timetrack()->UserObject);
			$this->dtgTimetracks->MetaAddColumn(QQN::Timetrack()->ProjectObject);
			$this->dtgTimetracks->MetaAddColumn('Date');
			$this->dtgTimetracks->MetaAddColumn('StartTime');
			$this->dtgTimetracks->MetaAddColumn('EndTime');
		}
	}
?>
