<?php
	require(__META_CONTROLS_GEN__ . '/TimetrackMetaControlGen.class.php');

	/**
	 * This is a MetaControl customizable subclass, providing a QForm or QPanel access to event handlers
	 * and QControls to perform the Create, Edit, and Delete functionality of the
	 * Timetrack class.  This code-generated class extends from
	 * the generated MetaControl class, which contains all the basic elements to help a QPanel or QForm
	 * display an HTML form that can manipulate a single Timetrack object.
	 *
	 * To take advantage of some (or all) of these control objects, you
	 * must create a new QForm or QPanel which instantiates a TimetrackMetaControl
	 * class.
	 *
	 * This file is intended to be modified.  Subsequent code regenerations will NOT modify
	 * or overwrite this file.
	 *
	 * @package My QCubed Application
	 * @subpackage MetaControls
	 */
	class TimetrackMetaControl extends TimetrackMetaControlGen {
		// Initialize fields with default values from database definition
/*
		public function __construct($objParentObject, Timetrack $objTimetrack) {
			parent::__construct($objParentObject,$objTimetrack);
			if ( !$this->blnEditMode ){
				$this->objTimetrack->Initialize();
			}
		}
*/
          //    
 	  // modification  by magia 2012 as suggested in qcubed-quick-start-guide_v210_Chapt_05 Change default value
          //   for data time field (Date, StartTime, EndTime).           

          // override generated metacontrols
		/**
		 * Create and setup QDateTimePicker calDate
		 * @param string $strControlId optional ControlId to use
		 * @return QDateTimePicker
		 */
		public function calDate_Create($strControlId = null) {
			$this->calDate = new QDateTimePicker($this->objParentObject, $strControlId);
			$this->calDate->Name = QApplication::Translate('Date');
			/* commented out as per qcubed quick start guide - chapt05 */  
			// $this->calDate->DateTime = $this->objTimetrack->Date;
			/* added */
			if  (!$this->blnEditMode)  {
				$this->calDate->DateTime = new QDateTime(QDateTime::Now);
			} else {
		   		$this->calDate->DateTime = $this->objTimetrack->Date;
			}
			
			$this->calDate->DateTimePickerType = QDateTimePickerType::Date;
			$this->calDate->Required = true;
			return $this->calDate;
		}

		/**
		 * Create and setup QDateTimePicker calStartTime
		 * @param string $strControlId optional ControlId to use
		 * @return QDateTimePicker
		 */
		public function calStartTime_Create($strControlId = null) {
			$this->calStartTime = new QDateTimePicker($this->objParentObject, $strControlId);
			$this->calStartTime->Name = QApplication::Translate('Start Time');
                        /* commented out as per qcubed quick start guide - chapt05 */  
			// $this->calStartTime->DateTime = $this->objTimetrack->StartTime;
			/* added  */
			if  (!$this->blnEditMode)  {
				$this->calStartTime->DateTime = new QDateTime(QDateTime::Now);
			} else {
	          		$this->calStartTime->DateTime = $this->objTimetrack->StartTime;
			}

			$this->calStartTime->DateTimePickerType = QDateTimePickerType::Time;
			$this->calStartTime->Required = true;
			return $this->calStartTime;
		}

		/**
		 * Create and setup QDateTimePicker calEndTime
		 * @param string $strControlId optional ControlId to use
		 * @return QDateTimePicker
		 */
		public function calEndTime_Create($strControlId = null) {
			$this->calEndTime = new QDateTimePicker($this->objParentObject, $strControlId);
			$this->calEndTime->Name = QApplication::Translate('End Time');
                        /* commented out as per qcubed quick start guide - chapt05 */  
			// $this->calEndTime->DateTime = $this->objTimetrack->EndTime;
			/* added  */
			if  (!$this->blnEditMode)  {
				$this->calEndTime->DateTime = new QDateTime(QDateTime::Now);
			}else {
			        $this->calEndTime->DateTime = $this->objTimetrack->EndTime;
			}
			
			$this->calEndTime->DateTimePickerType = QDateTimePickerType::Time;
			$this->calEndTime->Required = true;
			return $this->calEndTime;
		}		

		// added by magia 2012 chapter 07 step 7
		public function SaveTimetrack() {
                        if  (!$this->blnEditMode)  {
				$objUser = unserialize($_SESSION['User']);
				$this->objTimetrack->User = $objUser->Id;
				// we must unset lstUserObject so in parent function the relative line 
				// if ($this->lstUserObject) $this->objTimetrack->User = $this->lstUserObject->SelectedValue;
				// has no effect on $this->objTimetrack->User 
				$this->lstUserObject = False;
                	}
			parent::SaveTimetrack();
		}	
	}
?>