<?php
	/**
	 * This is a MetaControl class, providing a QForm or QPanel access to event handlers
	 * and QControls to perform the Create, Edit, and Delete functionality
	 * of the Timetrack class.  This code-generated class
	 * contains all the basic elements to help a QPanel or QForm display an HTML form that can
	 * manipulate a single Timetrack object.
	 *
	 * To take advantage of some (or all) of these control objects, you
	 * must create a new QForm or QPanel which instantiates a TimetrackMetaControl
	 * class.
	 *
	 * Any and all changes to this file will be overwritten with any subsequent
	 * code re-generation.
	 *
	 * @package My QCubed Application
	 * @subpackage MetaControls
	 * @property-read Timetrack $Timetrack the actual Timetrack data class being edited
	 * @property QLabel $IdControl
	 * @property-read QLabel $IdLabel
	 * @property QListBox $UserControl
	 * @property-read QLabel $UserLabel
	 * @property QListBox $ProjectControl
	 * @property-read QLabel $ProjectLabel
	 * @property QDateTimePicker $DateControl
	 * @property-read QLabel $DateLabel
	 * @property QDateTimePicker $StartTimeControl
	 * @property-read QLabel $StartTimeLabel
	 * @property QDateTimePicker $EndTimeControl
	 * @property-read QLabel $EndTimeLabel
	 * @property-read string $TitleVerb a verb indicating whether or not this is being edited or created
	 * @property-read boolean $EditMode a boolean indicating whether or not this is being edited or created
	 */

	class TimetrackMetaControlGen extends QBaseClass {
		// General Variables
		/**
		 * @var Timetrack objTimetrack
		 * @access protected
		 */
		protected $objTimetrack;
		/**
		 * @var QForm|QControl objParentObject
		 * @access protected
		 */
		protected $objParentObject;
		/**
		 * @var string strTitleVerb
		 * @access protected
		 */
		protected $strTitleVerb;
		/**
		 * @var boolean blnEditMode
		 * @access protected
		 */
		protected $blnEditMode;

		// Controls that allow the editing of Timetrack's individual data fields
		/**
		 * @var QLabel lblId
		 * @access protected
		 */
		protected $lblId;
		/**
		 * @var QListBox lstUserObject
		 * @access protected
		 */
		protected $lstUserObject;
		/**
		 * @var QListBox lstProjectObject
		 * @access protected
		 */
		protected $lstProjectObject;
		/**
		 * @var QDateTimePicker calDate
		 * @access protected
		 */
		protected $calDate;
		/**
		 * @var QDateTimePicker calStartTime
		 * @access protected
		 */
		protected $calStartTime;
		/**
		 * @var QDateTimePicker calEndTime
		 * @access protected
		 */
		protected $calEndTime;

		// Controls that allow the viewing of Timetrack's individual data fields
		/**
		 * @var QLabel lblUser
		 * @access protected
		 */
		protected $lblUser;
		/**
		 * @var QLabel lblProject
		 * @access protected
		 */
		protected $lblProject;
		/**
		 * @var QLabel lblDate
		 * @access protected
		 */
		protected $lblDate;
		/**
		 * @var QLabel lblStartTime
		 * @access protected
		 */
		protected $lblStartTime;
		/**
		 * @var QLabel lblEndTime
		 * @access protected
		 */
		protected $lblEndTime;

		// QListBox Controls (if applicable) to edit Unique ReverseReferences and ManyToMany References

		// QLabel Controls (if applicable) to view Unique ReverseReferences and ManyToMany References


		/**
		 * Main constructor.  Constructor OR static create methods are designed to be called in either
		 * a parent QPanel or the main QForm when wanting to create a
		 * TimetrackMetaControl to edit a single Timetrack object within the
		 * QPanel or QForm.
		 *
		 * This constructor takes in a single Timetrack object, while any of the static
		 * create methods below can be used to construct based off of individual PK ID(s).
		 *
		 * @param mixed $objParentObject QForm or QPanel which will be using this TimetrackMetaControl
		 * @param Timetrack $objTimetrack new or existing Timetrack object
		 */
		 public function __construct($objParentObject, Timetrack $objTimetrack) {
			// Setup Parent Object (e.g. QForm or QPanel which will be using this TimetrackMetaControl)
			$this->objParentObject = $objParentObject;

			// Setup linked Timetrack object
			$this->objTimetrack = $objTimetrack;

			// Figure out if we're Editing or Creating New
			if ($this->objTimetrack->__Restored) {
				$this->strTitleVerb = QApplication::Translate('Edit');
				$this->blnEditMode = true;
			} else {
				$this->strTitleVerb = QApplication::Translate('Create');
				$this->blnEditMode = false;
			}
		 }

		/**
		 * Static Helper Method to Create using PK arguments
		 * You must pass in the PK arguments on an object to load, or leave it blank to create a new one.
		 * If you want to load via QueryString or PathInfo, use the CreateFromQueryString or CreateFromPathInfo
		 * static helper methods.  Finally, specify a CreateType to define whether or not we are only allowed to
		 * edit, or if we are also allowed to create a new one, etc.
		 *
		 * @param mixed $objParentObject QForm or QPanel which will be using this TimetrackMetaControl
		 * @param integer $intId primary key value
		 * @param QMetaControlCreateType $intCreateType rules governing Timetrack object creation - defaults to CreateOrEdit
 		 * @return TimetrackMetaControl
		 */
		public static function Create($objParentObject, $intId = null, $intCreateType = QMetaControlCreateType::CreateOrEdit) {
			// Attempt to Load from PK Arguments
			if (strlen($intId)) {
				$objTimetrack = Timetrack::Load($intId);

				// Timetrack was found -- return it!
				if ($objTimetrack)
					return new TimetrackMetaControl($objParentObject, $objTimetrack);

				// If CreateOnRecordNotFound not specified, throw an exception
				else if ($intCreateType != QMetaControlCreateType::CreateOnRecordNotFound)
					throw new QCallerException('Could not find a Timetrack object with PK arguments: ' . $intId);

			// If EditOnly is specified, throw an exception
			} else if ($intCreateType == QMetaControlCreateType::EditOnly)
				throw new QCallerException('No PK arguments specified');

			// If we are here, then we need to create a new record
			return new TimetrackMetaControl($objParentObject, new Timetrack());
		}

		/**
		 * Static Helper Method to Create using PathInfo arguments
		 *
		 * @param mixed $objParentObject QForm or QPanel which will be using this TimetrackMetaControl
		 * @param QMetaControlCreateType $intCreateType rules governing Timetrack object creation - defaults to CreateOrEdit
		 * @return TimetrackMetaControl
		 */
		public static function CreateFromPathInfo($objParentObject, $intCreateType = QMetaControlCreateType::CreateOrEdit) {
			$intId = QApplication::PathInfo(0);
			return TimetrackMetaControl::Create($objParentObject, $intId, $intCreateType);
		}

		/**
		 * Static Helper Method to Create using QueryString arguments
		 *
		 * @param mixed $objParentObject QForm or QPanel which will be using this TimetrackMetaControl
		 * @param QMetaControlCreateType $intCreateType rules governing Timetrack object creation - defaults to CreateOrEdit
		 * @return TimetrackMetaControl
		 */
		public static function CreateFromQueryString($objParentObject, $intCreateType = QMetaControlCreateType::CreateOrEdit) {
			$intId = QApplication::QueryString('intId');
			return TimetrackMetaControl::Create($objParentObject, $intId, $intCreateType);
		}



		///////////////////////////////////////////////
		// PUBLIC CREATE and REFRESH METHODS
		///////////////////////////////////////////////

		/**
		 * Create and setup QLabel lblId
		 * @param string $strControlId optional ControlId to use
		 * @return QLabel
		 */
		public function lblId_Create($strControlId = null) {
			$this->lblId = new QLabel($this->objParentObject, $strControlId);
			$this->lblId->Name = QApplication::Translate('Id');
			if ($this->blnEditMode)
				$this->lblId->Text = $this->objTimetrack->Id;
			else
				$this->lblId->Text = 'N/A';
			return $this->lblId;
		}

		/**
		 * Create and setup QListBox lstUserObject
		 * @param string $strControlId optional ControlId to use
		 * @param QQCondition $objConditions override the default condition of QQ::All() to the query, itself
		 * @param QQClause[] $objOptionalClauses additional optional QQClause object or array of QQClause objects for the query
		 * @return QListBox
		 */
		public function lstUserObject_Create($strControlId = null, QQCondition $objCondition = null, $objOptionalClauses = null) {
			$this->lstUserObject = new QListBox($this->objParentObject, $strControlId);
			$this->lstUserObject->Name = QApplication::Translate('User Object');
			$this->lstUserObject->Required = true;
			if (!$this->blnEditMode)
				$this->lstUserObject->AddItem(QApplication::Translate('- Select One -'), null);

			// Setup and perform the Query
			if (is_null($objCondition)) $objCondition = QQ::All();
			$objUserObjectCursor = User::QueryCursor($objCondition, $objOptionalClauses);

			// Iterate through the Cursor
			while ($objUserObject = User::InstantiateCursor($objUserObjectCursor)) {
				$objListItem = new QListItem($objUserObject->__toString(), $objUserObject->Id);
				if (($this->objTimetrack->UserObject) && ($this->objTimetrack->UserObject->Id == $objUserObject->Id))
					$objListItem->Selected = true;
				$this->lstUserObject->AddItem($objListItem);
			}

			// Return the QListBox
			return $this->lstUserObject;
		}

		/**
		 * Create and setup QLabel lblUser
		 * @param string $strControlId optional ControlId to use
		 * @return QLabel
		 */
		public function lblUser_Create($strControlId = null) {
			$this->lblUser = new QLabel($this->objParentObject, $strControlId);
			$this->lblUser->Name = QApplication::Translate('User Object');
			$this->lblUser->Text = ($this->objTimetrack->UserObject) ? $this->objTimetrack->UserObject->__toString() : null;
			$this->lblUser->Required = true;
			return $this->lblUser;
		}

		/**
		 * Create and setup QListBox lstProjectObject
		 * @param string $strControlId optional ControlId to use
		 * @param QQCondition $objConditions override the default condition of QQ::All() to the query, itself
		 * @param QQClause[] $objOptionalClauses additional optional QQClause object or array of QQClause objects for the query
		 * @return QListBox
		 */
		public function lstProjectObject_Create($strControlId = null, QQCondition $objCondition = null, $objOptionalClauses = null) {
			$this->lstProjectObject = new QListBox($this->objParentObject, $strControlId);
			$this->lstProjectObject->Name = QApplication::Translate('Project Object');
			$this->lstProjectObject->Required = true;
			if (!$this->blnEditMode)
				$this->lstProjectObject->AddItem(QApplication::Translate('- Select One -'), null);

			// Setup and perform the Query
			if (is_null($objCondition)) $objCondition = QQ::All();
			$objProjectObjectCursor = Project::QueryCursor($objCondition, $objOptionalClauses);

			// Iterate through the Cursor
			while ($objProjectObject = Project::InstantiateCursor($objProjectObjectCursor)) {
				$objListItem = new QListItem($objProjectObject->__toString(), $objProjectObject->Id);
				if (($this->objTimetrack->ProjectObject) && ($this->objTimetrack->ProjectObject->Id == $objProjectObject->Id))
					$objListItem->Selected = true;
				$this->lstProjectObject->AddItem($objListItem);
			}

			// Return the QListBox
			return $this->lstProjectObject;
		}

		/**
		 * Create and setup QLabel lblProject
		 * @param string $strControlId optional ControlId to use
		 * @return QLabel
		 */
		public function lblProject_Create($strControlId = null) {
			$this->lblProject = new QLabel($this->objParentObject, $strControlId);
			$this->lblProject->Name = QApplication::Translate('Project Object');
			$this->lblProject->Text = ($this->objTimetrack->ProjectObject) ? $this->objTimetrack->ProjectObject->__toString() : null;
			$this->lblProject->Required = true;
			return $this->lblProject;
		}

		/**
		 * Create and setup QDateTimePicker calDate
		 * @param string $strControlId optional ControlId to use
		 * @return QDateTimePicker
		 */
		public function calDate_Create($strControlId = null) {
			$this->calDate = new QDateTimePicker($this->objParentObject, $strControlId);
			$this->calDate->Name = QApplication::Translate('Date');
			$this->calDate->DateTime = $this->objTimetrack->Date;
			$this->calDate->DateTimePickerType = QDateTimePickerType::Date;
			$this->calDate->Required = true;
			return $this->calDate;
		}

		/**
		 * Create and setup QLabel lblDate
		 * @param string $strControlId optional ControlId to use
		 * @param string $strDateTimeFormat optional DateTimeFormat to use
		 * @return QLabel
		 */
		public function lblDate_Create($strControlId = null, $strDateTimeFormat = null) {
			$this->lblDate = new QLabel($this->objParentObject, $strControlId);
			$this->lblDate->Name = QApplication::Translate('Date');
			$this->strDateDateTimeFormat = $strDateTimeFormat;
			$this->lblDate->Text = sprintf($this->objTimetrack->Date) ? $this->objTimetrack->Date->qFormat($this->strDateDateTimeFormat) : null;
			$this->lblDate->Required = true;
			return $this->lblDate;
		}

		protected $strDateDateTimeFormat;


		/**
		 * Create and setup QDateTimePicker calStartTime
		 * @param string $strControlId optional ControlId to use
		 * @return QDateTimePicker
		 */
		public function calStartTime_Create($strControlId = null) {
			$this->calStartTime = new QDateTimePicker($this->objParentObject, $strControlId);
			$this->calStartTime->Name = QApplication::Translate('Start Time');
			$this->calStartTime->DateTime = $this->objTimetrack->StartTime;
			$this->calStartTime->DateTimePickerType = QDateTimePickerType::Time;
			$this->calStartTime->Required = true;
			return $this->calStartTime;
		}

		/**
		 * Create and setup QLabel lblStartTime
		 * @param string $strControlId optional ControlId to use
		 * @param string $strDateTimeFormat optional DateTimeFormat to use
		 * @return QLabel
		 */
		public function lblStartTime_Create($strControlId = null, $strDateTimeFormat = null) {
			$this->lblStartTime = new QLabel($this->objParentObject, $strControlId);
			$this->lblStartTime->Name = QApplication::Translate('Start Time');
			$this->strStartTimeDateTimeFormat = $strDateTimeFormat;
			$this->lblStartTime->Text = sprintf($this->objTimetrack->StartTime) ? $this->objTimetrack->StartTime->qFormat($this->strStartTimeDateTimeFormat) : null;
			$this->lblStartTime->Required = true;
			return $this->lblStartTime;
		}

		protected $strStartTimeDateTimeFormat;


		/**
		 * Create and setup QDateTimePicker calEndTime
		 * @param string $strControlId optional ControlId to use
		 * @return QDateTimePicker
		 */
		public function calEndTime_Create($strControlId = null) {
			$this->calEndTime = new QDateTimePicker($this->objParentObject, $strControlId);
			$this->calEndTime->Name = QApplication::Translate('End Time');
			$this->calEndTime->DateTime = $this->objTimetrack->EndTime;
			$this->calEndTime->DateTimePickerType = QDateTimePickerType::Time;
			$this->calEndTime->Required = true;
			return $this->calEndTime;
		}

		/**
		 * Create and setup QLabel lblEndTime
		 * @param string $strControlId optional ControlId to use
		 * @param string $strDateTimeFormat optional DateTimeFormat to use
		 * @return QLabel
		 */
		public function lblEndTime_Create($strControlId = null, $strDateTimeFormat = null) {
			$this->lblEndTime = new QLabel($this->objParentObject, $strControlId);
			$this->lblEndTime->Name = QApplication::Translate('End Time');
			$this->strEndTimeDateTimeFormat = $strDateTimeFormat;
			$this->lblEndTime->Text = sprintf($this->objTimetrack->EndTime) ? $this->objTimetrack->EndTime->qFormat($this->strEndTimeDateTimeFormat) : null;
			$this->lblEndTime->Required = true;
			return $this->lblEndTime;
		}

		protected $strEndTimeDateTimeFormat;




		/**
		 * Refresh this MetaControl with Data from the local Timetrack object.
		 * @param boolean $blnReload reload Timetrack from the database
		 * @return void
		 */
		public function Refresh($blnReload = false) {
			if ($blnReload)
				$this->objTimetrack->Reload();

			if ($this->lblId) if ($this->blnEditMode) $this->lblId->Text = $this->objTimetrack->Id;

			if ($this->lstUserObject) {
					$this->lstUserObject->RemoveAllItems();
				if (!$this->blnEditMode)
					$this->lstUserObject->AddItem(QApplication::Translate('- Select One -'), null);
				$objUserObjectArray = User::LoadAll();
				if ($objUserObjectArray) foreach ($objUserObjectArray as $objUserObject) {
					$objListItem = new QListItem($objUserObject->__toString(), $objUserObject->Id);
					if (($this->objTimetrack->UserObject) && ($this->objTimetrack->UserObject->Id == $objUserObject->Id))
						$objListItem->Selected = true;
					$this->lstUserObject->AddItem($objListItem);
				}
			}
			if ($this->lblUser) $this->lblUser->Text = ($this->objTimetrack->UserObject) ? $this->objTimetrack->UserObject->__toString() : null;

			if ($this->lstProjectObject) {
					$this->lstProjectObject->RemoveAllItems();
				if (!$this->blnEditMode)
					$this->lstProjectObject->AddItem(QApplication::Translate('- Select One -'), null);
				$objProjectObjectArray = Project::LoadAll();
				if ($objProjectObjectArray) foreach ($objProjectObjectArray as $objProjectObject) {
					$objListItem = new QListItem($objProjectObject->__toString(), $objProjectObject->Id);
					if (($this->objTimetrack->ProjectObject) && ($this->objTimetrack->ProjectObject->Id == $objProjectObject->Id))
						$objListItem->Selected = true;
					$this->lstProjectObject->AddItem($objListItem);
				}
			}
			if ($this->lblProject) $this->lblProject->Text = ($this->objTimetrack->ProjectObject) ? $this->objTimetrack->ProjectObject->__toString() : null;

			if ($this->calDate) $this->calDate->DateTime = $this->objTimetrack->Date;
			if ($this->lblDate) $this->lblDate->Text = sprintf($this->objTimetrack->Date) ? $this->objTimetrack->Date->qFormat($this->strDateDateTimeFormat) : null;

			if ($this->calStartTime) $this->calStartTime->DateTime = $this->objTimetrack->StartTime;
			if ($this->lblStartTime) $this->lblStartTime->Text = sprintf($this->objTimetrack->StartTime) ? $this->objTimetrack->StartTime->qFormat($this->strStartTimeDateTimeFormat) : null;

			if ($this->calEndTime) $this->calEndTime->DateTime = $this->objTimetrack->EndTime;
			if ($this->lblEndTime) $this->lblEndTime->Text = sprintf($this->objTimetrack->EndTime) ? $this->objTimetrack->EndTime->qFormat($this->strEndTimeDateTimeFormat) : null;

		}



		///////////////////////////////////////////////
		// PROTECTED UPDATE METHODS for ManyToManyReferences (if any)
		///////////////////////////////////////////////





		///////////////////////////////////////////////
		// PUBLIC TIMETRACK OBJECT MANIPULATORS
		///////////////////////////////////////////////

		/**
		 * This will save this object's Timetrack instance,
		 * updating only the fields which have had a control created for it.
		 */
		public function SaveTimetrack() {
			try {
				// Update any fields for controls that have been created
				if ($this->lstUserObject) $this->objTimetrack->User = $this->lstUserObject->SelectedValue;
				if ($this->lstProjectObject) $this->objTimetrack->Project = $this->lstProjectObject->SelectedValue;
				if ($this->calDate) $this->objTimetrack->Date = $this->calDate->DateTime;
				if ($this->calStartTime) $this->objTimetrack->StartTime = $this->calStartTime->DateTime;
				if ($this->calEndTime) $this->objTimetrack->EndTime = $this->calEndTime->DateTime;

				// Update any UniqueReverseReferences (if any) for controls that have been created for it

				// Save the Timetrack object
				$this->objTimetrack->Save();

				// Finally, update any ManyToManyReferences (if any)
			} catch (QCallerException $objExc) {
				$objExc->IncrementOffset();
				throw $objExc;
			}
		}

		/**
		 * This will DELETE this object's Timetrack instance from the database.
		 * It will also unassociate itself from any ManyToManyReferences.
		 */
		public function DeleteTimetrack() {
			$this->objTimetrack->Delete();
		}



		///////////////////////////////////////////////
		// PUBLIC GETTERS and SETTERS
		///////////////////////////////////////////////

		/**
		 * Override method to perform a property "Get"
		 * This will get the value of $strName
		 *
		 * @param string $strName Name of the property to get
		 * @return mixed
		 */
		public function __get($strName) {
			switch ($strName) {
				// General MetaControlVariables
				case 'Timetrack': return $this->objTimetrack;
				case 'TitleVerb': return $this->strTitleVerb;
				case 'EditMode': return $this->blnEditMode;

				// Controls that point to Timetrack fields -- will be created dynamically if not yet created
				case 'IdControl':
					if (!$this->lblId) return $this->lblId_Create();
					return $this->lblId;
				case 'IdLabel':
					if (!$this->lblId) return $this->lblId_Create();
					return $this->lblId;
				case 'UserControl':
					if (!$this->lstUserObject) return $this->lstUserObject_Create();
					return $this->lstUserObject;
				case 'UserLabel':
					if (!$this->lblUser) return $this->lblUser_Create();
					return $this->lblUser;
				case 'ProjectControl':
					if (!$this->lstProjectObject) return $this->lstProjectObject_Create();
					return $this->lstProjectObject;
				case 'ProjectLabel':
					if (!$this->lblProject) return $this->lblProject_Create();
					return $this->lblProject;
				case 'DateControl':
					if (!$this->calDate) return $this->calDate_Create();
					return $this->calDate;
				case 'DateLabel':
					if (!$this->lblDate) return $this->lblDate_Create();
					return $this->lblDate;
				case 'StartTimeControl':
					if (!$this->calStartTime) return $this->calStartTime_Create();
					return $this->calStartTime;
				case 'StartTimeLabel':
					if (!$this->lblStartTime) return $this->lblStartTime_Create();
					return $this->lblStartTime;
				case 'EndTimeControl':
					if (!$this->calEndTime) return $this->calEndTime_Create();
					return $this->calEndTime;
				case 'EndTimeLabel':
					if (!$this->lblEndTime) return $this->lblEndTime_Create();
					return $this->lblEndTime;
				default:
					try {
						return parent::__get($strName);
					} catch (QCallerException $objExc) {
						$objExc->IncrementOffset();
						throw $objExc;
					}
			}
		}

		/**
		 * Override method to perform a property "Set"
		 * This will set the property $strName to be $mixValue
		 *
		 * @param string $strName Name of the property to set
		 * @param string $mixValue New value of the property
		 * @return mixed
		 */
		public function __set($strName, $mixValue) {
			try {
				switch ($strName) {
					// Controls that point to Timetrack fields
					case 'IdControl':
						return ($this->lblId = QType::Cast($mixValue, 'QControl'));
					case 'UserControl':
						return ($this->lstUserObject = QType::Cast($mixValue, 'QControl'));
					case 'ProjectControl':
						return ($this->lstProjectObject = QType::Cast($mixValue, 'QControl'));
					case 'DateControl':
						return ($this->calDate = QType::Cast($mixValue, 'QControl'));
					case 'StartTimeControl':
						return ($this->calStartTime = QType::Cast($mixValue, 'QControl'));
					case 'EndTimeControl':
						return ($this->calEndTime = QType::Cast($mixValue, 'QControl'));
					default:
						return parent::__set($strName, $mixValue);
				}
			} catch (QCallerException $objExc) {
				$objExc->IncrementOffset();
				throw $objExc;
			}
		}
	}
?>